/*
 * OpenDEM www.opendem.info
 * the code is under the unlicense license, do what you like
 */

package info.opendem.opendemtracker;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import info.opendem.opendemtracker.R;
import android.app.AlertDialog;
import android.app.Service;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Binder;
import android.os.Bundle;
import android.os.IBinder;
import android.os.StrictMode;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;
import android.widget.Toast;

public class Pressure extends Service implements LocationListener, SensorEventListener {
	private LocationManager locationManager;
	private SensorManager sensorManager = null;
	public List<Double> pressureList;
	private Float initialPressureDevice = null;
	// test for the first time
	String initialPressureAPI = null;
	Boolean weatherAPiStart = false;
	List<String> dataList;
	List<String> pressureListAll; 
	Date date;
	private boolean useHeightService = false;
	private Sensor pressure = null;
	private boolean weatherAPi = false;
	String heightInputType = "manual";
	String wApiStatus = ""; 
	private boolean timer = false;
    public boolean internet = true;
	Double wApiLon = null;
	Double wApiLat = null;
	Float wApiHeight = null;
	String wApiId = null;
	String wApiName = null;
	Double wApiDistance = null;
	private Float lastVal = null;
	private final IBinder mBinder = new LocalBinder();
	public Double presVal = 0.0 ; 
	public Double presValNew = 0.0;
	String sensorName = "";
	public Double initialPressure = null;
	public Integer pressureCounter = 0;
	public Integer presValNewCount = 0;
	public Double presValTest = 0.0;
	public Float pesValRaw = (float) 0.0;
	private String intentText = "";
	ScheduledExecutorService serviceTimer;

	
	// the Binder is essential so that the activity could access a methodf of the service
    public class LocalBinder extends Binder {
        Pressure getService() {
            return Pressure.this;
        }
    }
	
	@Override
	public IBinder onBind(Intent intend) {
		// TODO Auto-generated method stub 
		return mBinder;
	}

	// called every time from startService method form activity
	@SuppressWarnings("deprecation")
	@Override public void onStart(Intent intent, int startId) {
	
		// TODO Auto-generated method stub 
		  super.onStart(intent, startId);
		  float extras;
		  extras = intent.getExtras().getFloat("data"); 
		  try{
			//  Log.d("statusOpenDEM", "wApiId Test" + intent.getExtras().getString("stationId"));
			  if (intent.getExtras().getString("stationId").length() != 0){
			  wApiId  = intent.getExtras().getString("stationId");
			  //Log.d("statusOpenDEM", "wApiId Test" + wApiId);
			  }
		  } catch(Exception e){}
	      initialPressureDevice =  extras;
	      
	      // called for the first time
	    //  Log.d("statusOpenDEM", "initialPressureDevice "+initialPressureDevice);
	      
	      if(initialPressureDevice == -9999){
	    	    useHeightService = true;
	    	  	      } else {
	    	  	    	wApiHeight = initialPressureDevice;
	    	  	      }
	       // the height entered by the user
	    //  Log.d("statusOpenDEM", "height initialPressureDevice" + initialPressureDevice);
	      	}
	
	@Override
	public void onCreate() {
		super.onCreate();
		Toast.makeText(getApplicationContext(), "Service wurde gestartet onCreate",	Toast.LENGTH_LONG).show();
	//	Log.d("statusOpenDEM", "Service is started onCreate");
		date = new Date();
		dataList   = new ArrayList<String>();
		locationManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
        // Test if GPS is available
        if ( !locationManager.isProviderEnabled( LocationManager.GPS_PROVIDER ) ) {
        	intentText = "noGps";
         Intent intent = new Intent("status");
      	    sendLocationBroadcast(intent);
     //  	 Log.d("gps", "gps not available service");
        }
        if ( locationManager.isProviderEnabled( LocationManager.GPS_PROVIDER ) ) {
       //      Log.d("gps", "gps available service");
        	     }
  //GPS      
        locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
  //PressureSensor      
		sensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
		List<Sensor> sensoren = sensorManager.getSensorList(Sensor.TYPE_ALL);

		StringBuilder sensorInfo = new StringBuilder();

		pressureList = new ArrayList<Double>();
		pressureListAll = new ArrayList<String>();
// search for pressure sensor
		for (Sensor sensor : sensoren) {
			 switch (sensor.getType()){
		        case Sensor.TYPE_PRESSURE:
		        //	Log.d("pressureservice", "sensorTyp " + sensor.getName());
		        	sensorName = sensor.getName();
		        	pressure = sensor;
		// normal = 3 values, ui = 10, fastes = 14			
				//	sensorManager.registerListener(this, pressure, SensorManager.SENSOR_DELAY_NORMAL);
		        	sensorManager.registerListener(this, pressure, SensorManager.SENSOR_DELAY_FASTEST);
		        //	sensorManager.registerListener(this, pressure, SensorManager.SENSOR_DELAY_UI);
		        	break;
		    }
		}
		
		// no sensor available 
		if (sensorName.length() == 0){
			intentText = "noSensor";
	         Intent intent = new Intent("status");
	      	    sendLocationBroadcast(intent);
		}
	}

	@Override
	public void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	//	Log.d("statusOpenDEM", "onDestroy Service");
		// the listener must be unregistered
		
		if (sensorManager != null){
			sensorManager.unregisterListener(this,pressure);
		sensorManager = null;}
		
		if (locationManager != null){
		 locationManager.removeUpdates(this);
         locationManager = null;}
		
	//	Log.d("statusOpenDEM", "destroyed listeners");
				
	//	Toast.makeText(getApplicationContext(), "Service is destroyed", Toast.LENGTH_LONG).show();
	}

	public void onAccuracyChanged(Sensor arg0, int arg1) {
		// TODO Auto-generated method stub
		// Nothing is changing
		//Log.d("pressureservice", "accurracy "+ arg1);
	}

	
	// Barometer Sensor onChange
	public void onSensorChanged(SensorEvent event) {

		if (event.sensor == pressure) {
			float[] pValues = event.values.clone();
			pesValRaw = pValues[0];
			
			// get all pressure values for testing
		
			Calendar c = Calendar.getInstance(); 
			  String minutes = "";    
		        if (c.get(Calendar.MINUTE) < 10){
		        minutes = "0" + c.get(Calendar.MINUTE);}
		            else{
		            minutes = String.valueOf(c.get(Calendar.MINUTE));}
		        
		        String seconds = "";    
		        if (c.get(Calendar.SECOND) < 10){
		        seconds = "0" + c.get(Calendar.SECOND);}
		            else{
		            seconds = String.valueOf(c.get(Calendar.SECOND));}
		        
		        String 	millisec = "";    
		        if (c.get(Calendar.MILLISECOND) < 10){
		        seconds = "0" + c.get(Calendar.MILLISECOND);}
		            else{
		            seconds = String.valueOf(c.get(Calendar.MILLISECOND));}
		        
	// Log.d("pressureservice", c.get(Calendar.HOUR_OF_DAY)+":"+ minutes +":"+ seconds +":"+ millisec +","+ pValues[0]);
			    pressureListAll.add(c.get(Calendar.HOUR_OF_DAY)+":"+ minutes +":"+ seconds +":"+ millisec +","+ pValues[0]);
		        
			// check for outliers
		//  lowpassfilter is not working in this case
			
			    // initial Pressure with 20 values = 1,5 sec
			    if (pressureCounter < 20){
			//	Log.d("pressureservice", "counter " + pressureCounter);
				pressureCounter= pressureCounter +1;
				pressureList.add((double) pValues[0]);
			} else if (pressureCounter == 20){
			//	Log.d("pressureservice", "counter " + pressureCounter);
				 Integer listSize =  pressureList.size();
					for (int i=0; i < listSize; i++){
					presVal =  (presVal + pressureList.get(i));
				//	Log.d("pressureservice", "presVal " + presVal );
					}
					double presValM = presVal / listSize;
					
				//	Log.d("pressureservice", "first meanl " + presValM );

					// check for outliers and compute mean again if necessary
					for (int i=0; i < listSize; i++){
						presValTest = pressureList.get(i);
					//	Log.d("pressureservice", "presValTest " + presValTest );
						Double presAbs  = Math.abs(presValTest - presValM);
				//		Log.d("pressureservice", "presAbs " + presAbs );
						if (presAbs < 0.1){
							presValNew = presValNew + presValTest;
                            presValNewCount = presValNewCount +1;
						}
						}
					lastVal = (float) (presValNew / presValNewCount);	
				//	Log.d("pressureservice", "second  mean " + lastVal );
					pressureCounter= pressureCounter +1;
			} else {
				Float absSum = Math.abs(lastVal - pValues[0]);
				if (absSum < 0.2){
			    lastVal = pValues[0];
				pressureList.add((double) pValues[0]);
				}
			}
		//	Log.d("pressureservice", "lastVal" + lastVal);
		}
	}
	
	private void startTimerApi() {
		
	  //  final ScheduledExecutorService
		serviceTimer = Executors.newSingleThreadScheduledExecutor();
	    serviceTimer.scheduleWithFixedDelay(new Runnable()
	      {
	        public void run()
	        {
	        	 Calendar c = Calendar.getInstance(); 
	         // 	Log.d("statusOpenDEM", "new request from timer"+ c.get(Calendar.HOUR_OF_DAY)+":"+ c.get(Calendar.MINUTE) +":"+ c.get(Calendar.SECOND));
	        	getWeatherApi();
	        }
	        // initial delay, delay, timeunit
	        // 600 = 10 min

	      }, 600, 600, TimeUnit.SECONDS);}

// compute mean from the last 12 pressure values 
	public Double onGet() {
		presVal = (double) (pressureList.get(pressureList.size()-1) + pressureList.get(pressureList.size()-2) + pressureList.get(pressureList.size()-3) + pressureList.get(pressureList.size()-4)+ pressureList.get(pressureList.size()-5)+ pressureList.get(pressureList.size()-6)+ pressureList.get(pressureList.size()-7)+ pressureList.get(pressureList.size()-8)+ pressureList.get(pressureList.size()-9) + pressureList.get(pressureList.size()-10) + pressureList.get(pressureList.size()-11)+ pressureList.get(pressureList.size()-12));
     		presVal = presVal / 12;
			
	//	Log.d("pressureservice", "wert"+presVal);
		
		// remove from array 
     		if (pressureList.size() > 30){
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		pressureList.remove(0);
		}
	//	Log.d("pressure", "pressureList.size "+pressureList.size());
		return presVal;
	}
	
	// todo stopping when saved
	
	public void onStop(){
		// stop pressure sensor
		try{
	    sensorManager.unregisterListener(this,pressure);
		sensorManager = null;
	//	Log.d("pressureservice", "onStop Service");
		// gps stop
		 locationManager.removeUpdates(this);
         locationManager = null;
     //	Log.d("gps", "onStop Service");
     	serviceTimer.shutdown();} catch(Exception exception){}
	}
	
// GPS onLocationChanged
	  public void onLocationChanged(Location loc) {
		//  Log.d("gps", "change " + initialPressureAPI );
		  // get Inital Height from service
		   if (useHeightService == true){
			   wApiLon = loc.getLongitude();
				  wApiLat = loc.getLatitude();
				
				  
				  wApiHeight = (float) loc.getAltitude();
			   String input = readBugzillaDEM();
			//   Log.d("gps", "demserverice "+input);
			  //{"shape":[{"lat":40.712433,"lon":-76.504913}],"height":[307]}
			   try {
				JSONObject json = new JSONObject(input);
				JSONArray heightValue = json.getJSONArray("height");
				int height = heightValue.getInt(0);
				//initialPressureAPI = height;
				useHeightService = false;
				initialPressureDevice = (float) height;
			//	Log.d("gps", "height form severe "+ height);
			// set type of data source
				heightInputType = "service";
				
			} catch (JSONException e) {
				// todo exception handling if answer is not correct, use gps height and set this
				initialPressureDevice = wApiHeight;
				heightInputType = "gps";
			//	Log.d("statusOpenDEM", "initial hhe aus gps "+ initialPressureDevice);
				useHeightService = false;
				e.printStackTrace();
			}
		   }
		  
		  // request the weather api at the first request
		  if (initialPressureAPI == null){
				 //update progessBar
			  intentText= "logging";
	        	 Intent intent = new Intent("status");
	       	    sendLocationBroadcast(intent);
			  if (weatherAPiStart == false ){
				  weatherAPiStart = true;
				  startTimerApi();
			//  Log.d("gps", "request weather app ");
			  wApiLon = loc.getLongitude();
			  wApiLat = loc.getLatitude();
			  getWeatherApi();
			//  Toast.makeText(getApplicationContext(), "logging data!", Toast.LENGTH_LONG).show();
			//	 Log.d("statusOpenDEM", "logging data!");
		  }
		  }
		  if (initialPressureAPI != null){
			  Calendar c = Calendar.getInstance(); 
			  String minutes = "";    
		        if (c.get(Calendar.MINUTE) < 10){
		        minutes = "0" + c.get(Calendar.MINUTE);}
		            else{
		            minutes = String.valueOf(c.get(Calendar.MINUTE));}
		        String seconds = "";    
		        if (c.get(Calendar.SECOND) < 10){
		        seconds = "0" + c.get(Calendar.SECOND);}
		            else{
		            seconds = String.valueOf(c.get(Calendar.SECOND));}
		
     // 	Log.d("gps", c.get(Calendar.HOUR_OF_DAY)+":"+ minutes +":"+ seconds +", lat " + loc.getLatitude()+ " Acurracy "+ loc.getAccuracy() + " LuftdruckWApi "+ initialPressureAPI + " onGet " +onGet() + "filter "+ lastVal + "raw " + pesValRaw);
    	dataList.add(c.get(Calendar.HOUR_OF_DAY)+":"+ minutes +":"+ seconds +","+loc.getLongitude()+","+ loc.getLatitude() +"," + loc.getAccuracy() +"," + loc.getAltitude() + "," +initialPressureAPI+","+ onGet() + ","+ lastVal + "," + pesValRaw);
      	}	
      }
      
      public void onProviderDisabled(String provider) {
         // called when the GPS provider is turned off (user turning off the GPS on the phone)
    	  // todo
      }
      
      public void onProviderEnabled(String provider) {
         // called when the GPS provider is turned on (user turning on the GPS on the phone)
    	 
      }
      
      public void onStatusChanged(String provider, int status, Bundle extras) {
         // called when the status of the GPS provider changes
    	  String statusText = "";
    	  if (status == 0){
    		  statusText = "GPS OUT_OF_SERVICE";
    	      	  }
    	  if (status == 1){
    		  statusText = "GPS TEMPORARILY_UNAVAILABLE";
    	  }
    	  if (status == 2){
    		  statusText = "GPS AVAIBLE";
    	  }
    	//  Log.d("statusOpenDEM", "status changed "+ statusText + "status "+ status);
      }
      

      /**
       * TODO, here or via broadcast in the activity
       */
      private void warningAndFinish() {
      	 AlertDialog.Builder builder = new AlertDialog.Builder(this);
      	 Resources res = getResources();
      	 String text   = res.getString(R.string.noGPS);
      	 builder.setMessage(text); 
      	 builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
               public void onClick(DialogInterface dialog, int id) {
                   dialog.dismiss();
                  // finish(); 
               }
           });
      	 AlertDialog dialog = builder.create();
      	 dialog.show();
      }
      
      // get the weather api --> at the moment not a api but a servlet 
      public void getWeatherApi(){
    //	  Log.d("statusOpenDEM", "Weather API request");
        String input = readBugzilla();
        
    //    Log.d("statusOpenDEM", "input= " + input);
        
        if (input.equals("error")){
        	
        	//   Log.d("statusOpenDEM", "input if " + input);
        	   
        	initialPressure = onGet();	    
        	initialPressureAPI = "null";	
        	internet = false;
        	
        } else {
        
	 //  Log.d("gps", "Input "+input);
	    try {
	     JSONObject json = new JSONObject(input);
	    	// switch for lat/lon and StationsID could be used later
	    	if (wApiId == null){
	    		wApiDistance = json.getDouble("distance");
	    		wApiName = json.getString("name");
	    		 wApiId  = json.getString("name");
	    		String pressure = json.getString("pressure");
			//  	Log.d("gps", "initialPressureAPI "+initialPressureAPI +" name"+ wApiId);
				if (initialPressureAPI == null){
					initialPressureAPI = pressure;
					initialPressure = onGet();	    		
		    	//	Log.d("statusOpenDEM", "initialPressure aus Pressure "+ initialPressure);
				}
			//	Log.d("gps", "initialPressureAPI "+initialPressureAPI);
	    	} else {
	    		// request with the id of the station
	    	//	Log.d("statusOpenDEM", "pressureApi request with id");
	    		initialPressureAPI = json.getString("pressure");
	    			}
	    } catch (Exception e) {
	      e.printStackTrace();
	    }}}
      
   // read weather station data
  
  	public String readBugzilla() {
  		
  		/*This exception NetworkingOnMainThread is thrown when, well, you perform network activity on the UI thread. It has potential of blocking the main thread, since it waits until the network connection is finished before resuming, thus blocking the thread.*/
  		StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
  		StrictMode.setThreadPolicy(policy); 
  	  StringBuilder builder = new StringBuilder();
      HttpClient client = new DefaultHttpClient();
      String url = null;
      if (wApiId == null){
    	  // perhaps later or the wunderground API
    	  //url = "http://api.openweathermap.org/data/2.5/station/find?lat="+ wApiLat+"&lon="+ wApiLon+"&cnt=10&APPID=fefc60271878e2007d0bd07678b45113";   
       url = "http://www.opendem.info:8080/wetterStationen/GetNextStation?lat="+ wApiLat+"&lon="+ wApiLon;
      }
      else       {
     	      //url = "http://api.openweathermap.org/data/2.5/station?id="+ wApiId +"&APPID=fefc60271878e2007d0bd07678b45113";    	  
    	  //url = "http://www.opendem.info:8080/wetterStationen/GetStation?id="+ wApiId;
    	  //+ URLEncoder.encode(jsonParameter, "UTF-8")
    	  try {
			url = "http://www.opendem.info:8080/wetterStationen/GetStation?id="+ URLEncoder.encode(wApiId, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
      }
      
      HttpGet httpGet = new HttpGet(url);
      //HttpGet httpGet = new HttpGet("http://api.openweathermap.org/data/2.5/station/find?lat=55&lon=37&cnt=10");
      try {
        HttpResponse response = client.execute(httpGet);
        StatusLine statusLine = response.getStatusLine();
        int statusCode = statusLine.getStatusCode();
        if (statusCode == 200) {
          HttpEntity entity = response.getEntity();
          InputStream content = entity.getContent();
          BufferedReader reader = new BufferedReader(new InputStreamReader(content));
          String line;
          while ((line = reader.readLine()) != null) {
            builder.append(line);
          }
        } else {
        	builder.append("error");
        }
      } catch (ClientProtocolException e) {
        e.printStackTrace();
        builder.append("error");
      } catch (IOException e) {
        e.printStackTrace();
        builder.append("error");
      }
      
   
      return builder.toString();
    }

 // read DEM service
    
    	public String readBugzillaDEM() {
    		StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
    		StrictMode.setThreadPolicy(policy); 
        StringBuilder builder = new StringBuilder();
        HttpClient client = new DefaultHttpClient();
        String url = null;
        String jsonParameter = "{\"shape\":[{\"lat\":"+wApiLat+",\"lon\":"+wApiLon+"}]}";
         try {
			url = "http://elevation.mapzen.com/height?json="+ URLEncoder.encode(jsonParameter, "UTF-8") +"&api_key=elevation-4Gj-pR8";
		} catch (UnsupportedEncodingException e1) {
			e1.printStackTrace();
			initialPressureDevice = wApiHeight;
			heightInputType = "gps";
		}    	  
    	HttpGet httpGet = new HttpGet(url);
        //HttpGet httpGet = new HttpGet("http://api.openweathermap.org/data/2.5/station/find?lat=55&lon=37&cnt=10");
        try {
          HttpResponse response = client.execute(httpGet);
          StatusLine statusLine = response.getStatusLine();
          int statusCode = statusLine.getStatusCode();
          if (statusCode == 200) {
            HttpEntity entity = response.getEntity();
            InputStream content = entity.getContent();
            BufferedReader reader = new BufferedReader(new InputStreamReader(content));
            String line;
            while ((line = reader.readLine()) != null) {
              builder.append(line);
            }
          } else {
        	  // exception handling if something went wrong, set gps height
				initialPressureDevice = wApiHeight;
				heightInputType = "gps";
			//	Log.d("statusOpenDEM", "initial height from gps "+ initialPressureDevice);
				useHeightService = false;
          }
        } catch (ClientProtocolException e) {
        	 // exception handling if something went wrong, set gps height
    		initialPressureDevice = wApiHeight;
			heightInputType = "gps";
		//	Log.d("statusOpenDEM", "initial height from gps "+ initialPressureDevice);
			useHeightService = false;
          e.printStackTrace();
        } catch (IOException e) {
        	 // exception handling if something went wrong, set gps height
    		initialPressureDevice = wApiHeight;
			heightInputType = "gps";
			// Log.d("statusOpenDEM", "initial height from gps "+ initialPressureDevice);
			useHeightService = false;
          e.printStackTrace();
        }
        return builder.toString();
      }
  	
// update view status when logging 

  	private void sendLocationBroadcast(Intent intent){
  		intent.putExtra("status", intentText);
  		//intent.putExtra("status", "Logging"); 	    
  	    LocalBroadcastManager.getInstance(this).sendBroadcast(intent);
  	}
}